#             Autore: Roberto FULIGNI
#
#               Data: 17/11/2023
#    
#        Descrizione: Conversione di un numero intero da base 2 a base 10
#                     mediante il metodo della forma polinomiale.


s = input("Stringa rappresentante un numero intero in base 2: ")

ris = 0      # Risultato della conversione

i = len(s) - 1       # Indice della cifra da elaborare
                     # (si inizia dall'ultima, quella più a destra della stringa)

peso = 1             # Peso della cifra

while i >= 0:
    cifra = int(s[i])        # Converte il carattere s[i] in un numero intero

    if cifra >= 2:
        # La cifra non è valida, si emette un messaggio d'errore
        # e si termina il programma
        print("Cifra non valida:", cifra)
        exit()

    ris = ris + cifra*peso   # Aggiunge la cifra (moltiplicata per il suo peso)
                             # al risultato
    peso = peso * 2
    i = i - 1               # Spostamento a sinistra dell'indice della cifra

print ("Risultato della conversione in base 10:", ris)