#             Autore: Roberto FULIGNI
#
#               Data: 17/11/2023
#    
#        Descrizione: Conversione di un numero intero da base N a base 10,
#                     mediante il metodo della forma polinomiale,
#                     essendo N una base tra 2 e 9 scelta dall'utente.


print ("Inserire la base iniziale in cui rappresentare il numero. La base deve essere compresa tra 2 e 9.")
# Inserimento della base con validazione del dato immesso
b = 0
while b < 2 or b > 9:
    b = int(input("Base: "))

s = input("Stringa rappresentante un numero intero nella base scelta: ")

ris = 0      # Risultato della conversione

i = len(s) - 1       # Indice della cifra da elaborare
                     # (si inizia dall'ultima, quella più a destra della stringa)

peso = 1             # Peso della cifra

while i >= 0:
    cifra = int(s[i])        # Converte il carattere s[i] in un numero intero

    if cifra >= b:
        # La cifra non è valida, si emette un messaggio d'errore
        # e si termina il programma
        print("Cifra non valida:", cifra)
        exit()

    ris = ris + cifra*peso   # Aggiunge la cifra (moltiplicata per il suo peso)
                             # al risultato
    peso = peso * b
    i = i - 1               # Spostamento a sinistra dell'indice della cifra

print ("Risultato della conversione in base 10:", ris)